#include "car_physics.hpp"
#include <godot_cpp/classes/curve.hpp>
namespace godot {
void CarPhysics::_bind_methods() {
#define CLASSNAME CarPhysics
    GDPROPERTY_HINTED(oversteer_curve, Variant::OBJECT, PROPERTY_HINT_RESOURCE_TYPE, "Curve");
    GDPROPERTY_HINTED(understeer_curve, Variant::OBJECT, PROPERTY_HINT_RESOURCE_TYPE, "Curve");
}

void CarPhysics::_enter_tree() {
    this->set_use_custom_integrator(true);
}

void CarPhysics::_integrate_forces(PhysicsDirectBodyState3D *state) {

void CarPhysics::set_target_speed(float target) {
    this->target_speed = target;
}

float CarPhysics::get_target_speed() const {
    return this->target_speed;
}

void CarPhysics::set_current_steering(float steering) {
    this->current_steering = steering;
}

float CarPhysics::get_current_steering() const {
    return this->current_steering;
}

void CarPhysics::set_brake(bool brake) {
    this->brake = brake;
}

bool CarPhysics::get_brake() const {
    return this->brake;
}

void CarPhysics::set_oversteer_curve(Ref<Curve> curve) {
    this->oversteer_curve = curve;
}

Ref<Curve> CarPhysics::get_oversteer_curve() const {
    return this->oversteer_curve;
}

void CarPhysics::set_understeer_curve(Ref<Curve> curve) {
    this->understeer_curve = curve;
}

Ref<Curve> CarPhysics::get_understeer_curve() const {
    return this->understeer_curve;
}

const float CarPhysics::ACCELERATION{20.f};
const float CarPhysics::BRAKE_FORCE{5.f};
const float CarPhysics::UNDERSTEER_SPEED_MUL{0.f};
const float CarPhysics::OVERSTEER_SPEED_MUL{0.f};
}
