#ifndef CAR_PLAYER_HPP
#define CAR_PLAYER_HPP

#include "car_physics.hpp"
#include "utils/player.hpp"
#include <godot_cpp/classes/input_event.hpp>
#include <godot_cpp/classes/rigid_body3d.hpp>
#include <godot_cpp/classes/collision_shape3d.hpp>

namespace godot {
class CarPlayer : public CarPhysics,
                  public IPlayer {
    GDCLASS(CarPlayer, CarPhysics);
    static void _bind_methods();
public:
    virtual void setup_player_input(PlayerInput *input) override;
    virtual void spawn_at_position(Transform3D const &transform) override;
    virtual Node *to_node() override;

    void on_steer(Ref<InputEvent> event, float value);
    void on_brake(Ref<InputEvent> event, float value);
    void on_accelerate(Ref<InputEvent> event, float value);
private:
    const float max_speed{34.f};
    const float max_speed_reverse{10.f};
    const float steering_factor{1.f};
};
};

#endif // !CAR_PLAYER_HPP
